#include <stdio.h>
#include <stdlib.h>
#include "sockrtns.h"

#include <errno.h>
#include <sys/types.h>


main(int argc, char **argv)
{
    int s, port;
    short result[3];
    char buffer[256];

    if (argc != 4 && argc !=3)
    {
	printf("Usage: %s hostname port [message]\n\n", argv[0]);
	printf("If a message is specified, that is sent, otherwise\n");
        printf("stdin is sent.\n");
	exit(1);
    }

    port = atoi(argv[2]);

    s = OpenConnection(argv[1], port);
	
    if (s == -1)
	perror("opening connection");
    else
    {
	if (argc == 3)
	{
	    printf("Accepting input from stdin.\n");
	    dup2(s, 1);                        /* stdout becomes descriptor s */
	    execlp("cat", "cat", (char *) 0);  /* exec cat. */
	    perror("executing cat");
	}
	else
	    write(s, argv[2], strlen(argv[2]));
    }	
	
    close(s);
}

